
import java.util.*;
import java.awt.*;

public class CANT23Voltage extends CANT23{
  public static String ExperimentXMLFile = "voltage.xml";
  public static VoltageNet nullNet;
  public static VoltageExperiment experiment; 

  public static void main(String args[]){
System.out.println("initialize CANT Voltage");
    initRandom();
    readNewSystem();
    positionWindows();
    delayBetweenSteps=0;
  }
  

  protected static void readNewSystem() {
    nullNet = new VoltageNet();
	
    nets = NetManager.readNets(ExperimentXMLFile,nullNet);
    workerThread = new CANT23Voltage.WorkerThread();
    initializeExperiment();
    experiment.printExpName();
    VoltageNet net = (VoltageNet) experiment.getNet("BaseNet");
    workerThread.start();	
    //connectAllNets();	
  }
  
  //set up the experiment specific parameters.
  private static void initializeExperiment() {
    experiment = new VoltageExperiment();
    System.out.println("initialize Voltage Experiment");
    experiment.printExpName();
  }
  
  public static void runOneStepStart() {
    if (experiment.trainingLength == CANTStep) experiment.switchToTest();
    if (experiment.getInTest()) experiment.measure(CANTStep);
  
    if (experiment.isEndEpoch(CANTStep))
       experiment.endEpoch();
  }
  
  public static synchronized void runOneStep() {
    //runOneStepStart();

    Enumeration eNum = nets.elements();
    while (eNum.hasMoreElements()) {
    VoltageNet net = (VoltageNet)eNum.nextElement();
    if (net.getName().compareTo("BaseNet") == 0)
      {
      net.runAllOneStep(CANTStep); 
      CANTStep++;
      }
    }
   
    //System.out.println("Incremenet cantvis1step"+CANTStep);

  if (experiment.experimentDone(CANTStep)) 
    {
//System.out.println("experiment done"+CANTStep);
        closeSystem();
  	//numSystems++;
  	readNewSystem();
  	//makeNewSystem(numSystems);
    }
  }
  
  
  private  static void positionWindows() {
    VoltageNet baseNet = (VoltageNet)experiment.getNet("BaseNet");
  
    baseNet.cantFrame.setLocation(0,0);
    baseNet.cantFrame.setSize (500,200);
    //baseNet.cantFrame.matrix.addStringsToPrint ("Follow",30);
    //baseNet.cantFrame.show();
  }
  
  //embedded Thread class
  public static class WorkerThread extends CANT23.WorkerThread{
    public void run(){
      System.out.println("Voltage Thread ");
      while(true){
         if(isRunning){
           runOneStep();
         }
         else{
           try{sleep(delayBetweenSteps);}
		   catch(InterruptedException ie){ie.printStackTrace();}
             }//else
       }//while
    }//run
  }//WorkerThread class
  
}