import java.io.*;
import java.util.*;

public class VoltageNet extends CANTNet {
  
  
  public VoltageNet(){
  }
  
  public VoltageNet(String name,int cols, int rows,int topology){
    super(name,cols,rows,topology);
    openInputReadFile();
  }

  //need this to subclass experiment
  public void changePattern(int cantStep)
  {
//    curPattern = CANT23.experiment.selectPattern(curPattern, patterns.size(),this);
     setCurrentPattern(0);
    //((CANTPattern)patterns.get(curPattern)).arrange(neuronsToStimulate);
    ((CANTPattern)patterns.get(getCurrentPattern())).arrange(50);
  }

   //open the input.txt file to read input voltages
   private    LineNumberReader voltageInputFile;
   private void openInputReadFile() {
     DataInputStream dIS;
     InputStreamReader inputSR;
 
     try{
       dIS = new DataInputStream(new FileInputStream("input.txt"));
       inputSR = new InputStreamReader(dIS);
       voltageInputFile = new LineNumberReader (inputSR);
     }
   
     catch (IOException e) {
       System.err.println("input.txt voltage file not opened properly\n" +
                         e.toString());
       System.exit(1);
     }
  }
  
   private double readInputVoltage(int CANTStep) {
     String inputLine;
     StringTokenizer tokenizedLine;
     String paramString;
     int testStep=-1;
     Double tempDouble;
     double weight = 0.0;
     try {
       inputLine = voltageInputFile.readLine(); //read row
       tokenizedLine = new StringTokenizer(inputLine);
       paramString=tokenizedLine.nextToken();
       testStep = Integer.parseInt(paramString);
       testStep /=100;
       paramString=tokenizedLine.nextToken();
       tempDouble = new Double(paramString);
       weight =  tempDouble.doubleValue();
       weight /= 1000;
     }

     catch (IOException e) {
       System.err.println("input.txt file not read properly\n" +
                           e.toString());
       System.exit(1);}
      
     //System.out.println("setExtern2 "+ weight + " " +
     //testStep + " " + (CANTStep+1));

     return weight;
   }
  
  
   //overload set external to get 1 neuron firing each time (except when 0)
    /**/
   public void setExternalActivation(int CANTStep) {
     //System.out.println("setExtern "+ CANTStep);
     CANTPattern pattern = (CANTPattern)patterns.get(0);
     //change weight of 1->0connection based on input

     double newWeight = readInputVoltage(CANTStep);
     //activate it.
     this.neurons[1].synapses[0].setWeight(newWeight);
     if (newWeight != 0.0)
       activate(pattern.getPatternIndex(0), (double)10.0);
   }
  
  public void runAllOneStep(int CANTStep) {
    //This series of loops is really chaotic, but I needed to
    //get all of the propogation done in each net in step.
    CANT23Voltage.runOneStepStart();
	
    Enumeration eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      //net.runOneStep(CANTStep);
      net.changePattern(CANTStep);
    }
    eNum = CANT23.nets.elements();
	while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement(); 
      net.setExternalActivation(CANTStep);
  }
      //net.propogateChange();  
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      net.spontaneousActivate();
    }
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      net.setNeuronsFired();
    }

    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      net.setDecay ();
    }
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      net.spreadActivation();
    }
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      //changed from template
      net.neurons[0].modifyFatigue();
      //net.setFatigue();
    }
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      net.learn();
    }
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      net.cantFrame.runOneStep(CANTStep+1);
    }
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
      VoltageNet net = (VoltageNet)eNum.nextElement();
      if (net.recordingActivation) net.setMeasure(CANTStep); 	  
    }
    measure(CANTStep);
  }


  public CANTNet getNewNet(String name,int cols, int rows,int topology){
  	VoltageNet net = new VoltageNet (name,cols,rows,topology);
	return (net);
	} 

	
  private void setTopology() {
    addConnection(1,0,0.3);
    //addConnection(1,0,0.6);
    //addConnection(1,0,0.9);
  }
  
  public void initializeNeurons() {
    //set up topologies.
    createNeurons();
															  
    if (topology == 1){
      System.out.println("input parse topology ");
      setTopology();
    }
    else  System.out.println("bad toppology specified "+ topology);
  }
/*  
  public void connectControlToAction(undoneNet actionNet) {
    //Top control CA suppress action
    for (int neuronNum=0; neuronNum<200;neuronNum++) 
      {
      if (neurons[neuronNum].isInhibitory())
        for (int synapseNum=0;synapseNum < 100; synapseNum++) 
          neurons[neuronNum].addConnection(
            actionNet.neurons[(int)(Math.random()*actionNet.getSize())],-1.0);
    }
	
	//Bottom may support it
  }
  
  */


  public void kludge () {
    System.out.println("voltage kludge ");
    
    Enumeration eNum = CANT23.nets.elements();
    VoltageNet voltageNet = (VoltageNet)eNum.nextElement();
    VoltageNet net;
    eNum = CANT23.nets.elements();
    while (eNum.hasMoreElements()) {
       net = (VoltageNet)eNum.nextElement();
       if (net.getName().compareTo("BaseNet") == 0)
       voltageNet =  net;
    }
    System.out.println(0 + " " + voltageNet.neurons[0].getActivation() + " " + 
      voltageNet.neurons[0].getFatigue());
    /*
	VoltageExperiment exp = (VoltageExperiment)CANT23undone.experiment;
	exp.timeOfCommand++;
	exp.emitCommand(2);
  	undoneNet actionNet;
	
	//clear all nets except input and stacktop
	Enumeration eNum = CANT23.nets.elements();
	actionNet= (undoneNet)eNum.nextElement();
	eNum = CANT23.nets.elements();
	while (eNum.hasMoreElements()) {
	  CANTNet net = (CANTNet)eNum.nextElement();
	  if (net.getName().compareTo("ActionNet") == 0)
	  	actionNet = (undoneNet) net;
	}

    // print rule activation
	for (int i= 0; i < 400; i++) 
	  {
	  System.out.println(i + " " + actionNet.neurons[i].getActivation());
	  }
	  */
  }
  
  public void measure(int currentStep) {
    if (neurons[0].getFired()) 
      System.out.println(currentStep);
  }
}